#include <QtQuick>

class MyImageProvider: public QQuickImageProvider {
public:
    MyImageProvider()
        : QQuickImageProvider(QQmlImageProviderBase::Image)
    {
    }

    QImage requestImage(const QString &id, QSize *size, const QSize &requestedSize)
    {
        QImage result(requestedSize, QImage::Format_ARGB32);
        QPainter p(&result);
        result.fill(Qt::transparent);
        p.setBrush(QColor(id));
        p.drawEllipse(0, 0, requestedSize.width() - 1, requestedSize.height() - 1);
        if (size)
            *size = requestedSize;
        return result;
    }
};

int main(int argc, char *argv[])
{
    QGuiApplication app(argc, argv);

    QQmlApplicationEngine engine;
    engine.addImageProvider("myImageProvider", new MyImageProvider);
    engine.load(QUrl(QStringLiteral("qrc:///main.qml")));

    return app.exec();
}
